/*
 * AbstractFAtoRGConverter.cpp
 *
 *  Created on: 27. 2. 2014
 *      Author: tomas
 */

#include "AbstractFAtoRGConverter.h"

using namespace alib;
using namespace automaton;
using namespace grammar;

namespace conversions
{

AbstractFAtoRGConverter::AbstractFAtoRGConverter( const FSM & fsm ) : m_fsm( fsm )
{
    if( ! m_fsm.isEpsilonFree( ) )
        throw AlibException( "FSM has epsilon transitions" );
}

void AbstractFAtoRGConverter::createNonTerminalSymbols( RegularGrammar & rg ) const
{
    for( const auto & state : m_fsm.getStates( ) )
        rg.addNonTerminalSymbol( Symbol( state.getName( ) ) );
}

void AbstractFAtoRGConverter::createTerminalSymbols( RegularGrammar & rg ) const
{
    for( const auto & symbol : m_fsm.getInputAlphabet( ) )
        rg.addTerminalSymbol( symbol );
}

} /* namespace conversions */
