#ifndef __REG_EXP_LEXER__
#define __REG_EXP_LEXER__

#include <string>
#include <iostream>

class RegExpLexer {
public:
  enum TokenType {
    SYMBOL,
    LPAR,
    RPAR,
    PLUS,
    STAR,
    EPS,
    EMPTY,
    TEOF,
    ERROR
  };

  struct Token {
    TokenType type;
    std::string value;
  };
private:
  std::istream& m_In;
  Token m_Current;
public:
  
  RegExpLexer(std::istream&);
  RegExpLexer& next();
  Token token();
};

#endif