#include <iostream>
#include <set>

#include "automaton/UnknownAutomaton.h"
#include "AutomatonFactory.h"
#include "AlibException.h"
#include "IDPDADeterminizer.h"


using namespace std;
using namespace automaton;
using namespace determinization;
using namespace alib;


int main(int argc, char** argv) {
    UnknownAutomaton automaton;
    
    try {
        string input(istreambuf_iterator<char>(cin), (istreambuf_iterator<char>()));
        automaton = AutomatonFactory::fromString(input);
        
        Automaton* knownAutomaton = AutomatonFactory::buildAutomaton(automaton);
        // TODO check that automaton is FSM
        IDPDADeterminizer determinizer((PDA*) knownAutomaton);
        PDA* deterministicIDPDA = determinizer.determinize();
        deterministicIDPDA->toXML(cout);
        
        delete knownAutomaton;
        delete deterministicIDPDA;
        
    } catch (AlibException& e) {
        cout << e.what() << endl;
        return 0;
    }
}