/*
 * RegExpFactory.cpp
 *
 *  Created on: Jan 1, 2014
 *      Author: martin
 */

#include <iostream>

#include "sax/SaxInterface.h"
#include "RegExpFactory.h"
#include "regexp/RegExpParser.h"

namespace regexp {

RegExp RegExpFactory::fromFile(const string& filename) {
	std::list<Token> tokens;
	SaxInterface::parseFile(filename, tokens);
	return parse(tokens);
}

RegExp RegExpFactory::fromString(const string& str) {
	list<Token> tokens;
	SaxInterface::parseMemory(str, tokens);
	return parse(tokens);
}

RegExp RegExpFactory::fromStdin() {
	return RegExpFactory::fromStream(cin);
}

RegExp RegExpFactory::fromStream(std::istream& in) {
	string input(istreambuf_iterator<char>(in), (istreambuf_iterator<char>()));
	return RegExpFactory::fromString(input);
}

RegExp RegExpFactory::parse(list<sax::Token> tokens) {
	RegExpParser parser;
	return parser.parse(tokens);
}

} /* namespace regexp */
