/*
 * UnknownGrammar.cpp
 *
 *  Created on: Nov 3, 2013
 *      Author: martin
 */

#include "UnknownGrammar.h"
#include "GrammarException.h"

namespace grammar {

bool UnknownGrammar::isValidRule(const Rule& rule) const {
	for (auto const & symbol : rule.getLeftSide()) {
		if (terminalSymbols.find(symbol) == terminalSymbols.end()
				&& nonTerminalSymbols.find(symbol) == nonTerminalSymbols.end()) {
			return false;
		}
	}

	for (auto const & right : rule.getRightSide()) {
		if (terminalSymbols.find(right) == terminalSymbols.end()
				&& nonTerminalSymbols.find(right) == nonTerminalSymbols.end()) {
			return false;
		}
	}

	return true;
}

} /* namespace grammar */

