/*
 * StringPrinter.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef STRING_PRINTER_H_
#define STRING_PRINTER_H_

#include <ostream>
#include "String.h"

namespace notions {
namespace string {

/**
 * This class contains methods to print XML representation of regular expression to the output stream.
 */
class StringPrinter {
protected:
	static const std::string INDENTATION;
	static void printContent(String& element, std::ostream& out, std::string prefix);
	static void printAlphabet(String& content, std::ostream& out, std::string prefix);
	static void printSymbol(alphabet::Symbol& symbol, std::ostream& out, std::string prefix);
public:
	/**
	 * Prints XML representation of RegExp to the output stream.
	 * @param regexp RegExp to print
	 * @param out output stream to which print the RegExp
	 */
	static void toXML(notions::string::String& regexp, std::ostream& out);
};

} /* namespace string */
} /* namespace notions */
#endif /* STRING_PRINTER_H_ */
