/*
 * RegExpOptimize.h
 *
 *  Created on: 20. 1. 2014
 *      Author: tomas
 */

#ifndef REGEXPOPTIMIZE_H_
#define REGEXPOPTIMIZE_H_

#include <regexp/RegExp.h>
#include <regexp/RegExpElement.h>
#include <regexp/Alternation.h>
#include <regexp/Concatenation.h>
#include <regexp/Iteration.h>
#include <regexp/RegExpSymbol.h>
#include <regexp/RegExpEmpty.h>
#include <regexp/RegExpEpsilon.h>

#include <AlibException.h>

class RegExpOptimize
{
public:
    regexp::RegExp optimize( const regexp::RegExp & regexp );
    regexp::RegExpElement * optimize( const regexp::RegExpElement* node );
    regexp::RegExpElement * optimize( const regexp::Alternation * node );
    regexp::RegExpElement * optimize( const regexp::Concatenation * node );
    regexp::RegExpElement * optimize( const regexp::Iteration * node );
    regexp::RegExpElement * optimize( const regexp::RegExpSymbol * node );
    regexp::RegExpElement * optimize( const regexp::RegExpEpsilon * node );
    regexp::RegExpElement * optimize( const regexp::RegExpEmpty * node );
};

#endif /* REGEXPNORMALIZE_H_ */
